/**
 * Created by Administrator on 2017/6/27.
 */
var spawn = require('child_process').spawn;
var EventEmitter = require('events').EventEmitter;
var util = require('util');
var fs = require('../utils/file');
var LeScanner = require("../tool/ble_scan_once");

var BluetoothScanner = module.exports = function (option, callback) {
    var self = this;

    // Inherit EventEmitter
    EventEmitter.call(self);

    self.init = function (option) {
        console.log("connect index:" + JSON.stringify(option));
        var hcidev = 'hci0';
        var macAddr = option['mac'];
        var mobile = option['mobile'];
        var devicename = option['name'];
        var mi = Number(option['mi']);
        var flag = option['flag'];
        var mobileopt = option['mobileopt'];
        var userid = option['userid'];
        var time = option['time'];
        var number = option['number'];
        var record_time = new Date().getTime();
        var connect_time = 0;
        var disconnect_time = 0;
        var lescan_time = 0;
        var connect_rp = "";
        var args = {};

        // Bring selected device UP
        var hciconfig = spawn('hciconfig', [hcidev, 'up']);

        hciconfig.on("exit", function (code) {
            //启动蓝牙失败
            if (code !== 0) {
                console.log("hcitool Device " + hcidev + "up fail!");
                callback({"result": 0, "value": "蓝牙启动失败！"});
            }
            else {
                console.log("Device " + hcidev + "up suceed!");
                //扫描参数
                var scan_params = {
                    "mac": macAddr,
                    "flag": flag,
                    "mi": mi,
                    "mobile": mobile,
                    "name": devicename,
                    "parameter": {
                        "scan_interval": mobileopt["scan_interval"],
                        "scan_window": mobileopt["scan_window"]
                    },
                    "userid": userid
                };
                //扫描mac
                bleScanner = new LeScanner(scan_params, function (data) {
                    console.log("返回扫描结果:" + JSON.stringify(data));
                    if (data["value"] === "succeed") {
                        var RSSI = data["RSSI"];
                        lescan_time = data["LeScanEndtime"] - data["LeScanBegintime"];
                        console.log("扫描:" + macAddr + ",成功！");
                        console.log("扫描时间：" + lescan_time + "ms");
                        //begin Connect
                        var begin_time = new Date();
                        var end_time = new Date();

                        var hciToolScan;
                        if (data["gapAddrType"] === 0) {                //"PUBLIC"
                            hciToolScan = spawn('hcitool', ['EdInt', macAddr, mobileopt["connect_interval"], mobileopt["connect_window"], mobileopt["connect_min_interval"], mobileopt["connect_max_interval"]]);
                            console.log("hcitool EdInt: started..." + ['EdInt', macAddr, mobileopt["connect_interval"], mobileopt["connect_window"], mobileopt["connect_min_interval"], mobileopt["connect_max_interval"]]);
                        } else if (data["gapAddrType"] === 1) {         //"RANDOM"
                            hciToolScan = spawn('hcitool', ['EdInt', "--random", macAddr, mobileopt["connect_interval"], mobileopt["connect_window"], mobileopt["connect_min_interval"], mobileopt["connect_max_interval"]]);
                            console.log("hcitool EdInt: started..." + ['EdInt', "--random", macAddr, mobileopt["connect_interval"], mobileopt["connect_window"], mobileopt["connect_min_interval"], mobileopt["connect_max_interval"]]);
                        }

                        //var hciToolScan;
                        //if (data["gapAddrType"] === 0) {     //"PUBLIC"
                        //    hciToolScan = spawn('hcitool', ['EdInt', macAddr, mobileopt["connect-interval"], mobileopt["connect-window"], mobileopt["connect-min_interval"], mobileopt["connect-max_interval"]]);
                        //    console.log("hcitool EdInt: started..." + ['EdInt', macAddr, mobileopt["connect-interval"], mobileopt["connect-window"], mobileopt["connect-min_interval"], mobileopt["connect-max_interval"]]);
                        //} else if (data["gapAddrType"] === 1) {      //"RANDOM"
                        //    hciToolScan = spawn('hcitool', ['EdInt', "--random", macAddr, mobileopt["connect-interval"], mobileopt["connect-window"], mobileopt["connect-min_interval"], mobileopt["connect-max_interval"]]);
                        //    console.log("hcitool EdInt: started..." + ['EdInt',"--random", macAddr, mobileopt["connect-interval"], mobileopt["connect-window"], mobileopt["connect-min_interval"], mobileopt["connect-max_interval"]]);
                        //}

                        //var hciToolScan;
                        //if (data["gapAddrType"] === 0) {     //"PUBLIC"
                        //    hciToolScan = spawn('hcitool', ['lecc', macAddr]);
                        //    console.log("hcitool: started..." + ['lecc', macAddr]);
                        //} else if (data["gapAddrType"] === 1) {      //"RANDOM"
                        //    hciToolScan = spawn('hcitool', ['lecc', "--random", macAddr]);
                        //    console.log("hcitool：started..." + ['lecc', "--random", macAddr]);
                        //}

                        console.log("连接设备:" + macAddr);
                        hciToolScan.stdout.on('data', function (data) {
                            if (data.length) {
                                end_time = new Date();
                                //console.log("连接成功!");
                                console.log("设备名称:" + option['name'] + "|mac:" + option['mac'] + "|RSSI:" + RSSI);
                                connect_time = (end_time.getTime() - begin_time.getTime());
                                console.log('\t' + "连接时间:" + connect_time + "ms");
                                data = data.toString('utf-8');
                                connect_rp = data;
                                // 断开handle
                                if (data.indexOf('Connection handle ') === 0) {
                                    var handleValue = data.replace("Connection handle ", "");
                                    handleValue = handleValue.replace("/n", "");
                                    console.log("handlevalue:" + handleValue);
                                    var handleEndtime = new Date();
                                    console.log("第一次超时6秒-1：" + new Date())
                                    setTimeout(function () {
                                        console.log("第一次超时6秒-2：" + new Date())
                                        //断开操作
                                        var hciToolScans = spawn('hcitool', ['ledc', handleValue]);
                                        hciToolScans.on('exit', function (code) {
                                            if (code !== 0) {
                                                console.log("lecc succeed ledc failed!");
                                                var hciconfig = spawn('hciconfig', [hcidev, 'down']);
                                                hciconfig.on("exit", function (code) {
                                                    if (code !== 0) {
                                                        console.log("Device " + hcidev + "down failed!");
                                                    }
                                                    else {
                                                        console.log("Device " + hcidev + "down succeed!");
                                                    }
                                                });
                                            } else {
                                                disconnect_time = (new Date().getTime() - handleEndtime);
                                                console.log("断开成功!");
                                                console.log('\t' + "断开时间:" + disconnect_time + "ms");
                                                console.log("lecc succeed ledc succeed!");
                                                var hciconfig = spawn('hciconfig', [hcidev, 'down']);
                                                hciconfig.on("exit", function (code) {
                                                    if (code !== 0) {
                                                        console.log("Device " + hcidev + "down failed!");
                                                    }
                                                    else {
                                                        console.log("Device " + hcidev + "down succeed!");
                                                    }
                                                });
                                            }

                                            args = {
                                                "mac": macAddr,
                                                "ConnectionTime": connect_time,
                                                "DisconnectTime": disconnect_time,
                                                "flag": flag,
                                                "name": devicename,
                                                "mi": mi,
                                                "time": record_time,
                                                "mobile": mobile,
                                                "LescanTime": lescan_time,
                                                "RSSI": RSSI,
                                                "isConnect": 1,
                                                "isScan": 1,
                                                "result": "连接成功！",
                                                "mark": connect_rp,
                                                "userid": userid
                                            };
                                            fs("./files/ble_connect/" + time + '手机-' + mobile
                                                + '-设备' + devicename + '-次数' + number + '-距离-' + mi + ".txt", args);
                                        });

                                        callback({
                                            "result": 1,
                                            "value": "成功！连接时间：" + connect_time + "ms，扫描时间：" + lescan_time + "ms！"
                                        });
                                    }, 6000)

                                }
                            }
                        });

                        hciToolScan.on("exit", function (code) {
                            console.log("exit:" + code);

                            if (code !== 0) {
                                //记录只扫描不连接的次数
                                args = {
                                    "mac": macAddr,
                                    "ConnectionTime": 0,
                                    "DisconnectTime": 0,
                                    "flag": flag,
                                    "name": devicename,
                                    "mi": mi,
                                    "time": record_time,
                                    "mobile": mobile,
                                    "LescanTime": lescan_time,
                                    "RSSI": RSSI,
                                    "isConnect": 0,
                                    "isScan": 1,
                                    "result": "连接失败！",
                                    "mark": connect_rp,
                                    "userid": userid
                                };
                                fs("./files/ble_connect/" + time + '手机-' + mobile
                                    + '-设备' + devicename + '-次数' + number + '-距离-' + mi + ".txt", args);
                                callback({"result": 0, "value": "失败！扫描时间：" + lescan_time + "ms！"});
                            }
                            else {
                                console.log("连接成功!");
                                console.log('\t' + "连接成功退出时间:" + (new Date().getTime() - begin_time) + "ms");
                            }
                        });
                    }
                    else {
                        console.log("扫描:" + macAddr + ",失败！");
                        console.log("扫描时间：" + (data["LeScanEndtime"] - data["LeScanBegintime"]) + "ms");
                        var hciconfig = spawn('hciconfig', [hcidev, 'down']);
                        hciconfig.on("exit", function (code) {
                            if (code !== 0) {
                                console.log("hcitool Device " + hcidev + "down fail!");
                            }
                            else {
                                console.log("hcitool Device " + hcidev + "down suceed!");
                            }
                            callback({"result": 0, "value": "失败！扫描超时！"});
                        });
                    }
                });
            }
        });
    };
    self.init(option);
};
util.inherits(BluetoothScanner, EventEmitter);